<# 
.SYNOPSIS
		Send email to newly created mailboxes

.DESCRIPTION


.NOTES
    Version    	      	: v1.3 - See changelog at http://www.ehloworld.com/589
    Wish list						: 
    Rights Required			: Exchange Recipient Administrator role (unverified)
    Sched Task Req'd		: Yes - see http://www.ehloworld.com/133
    Lync Version				: N/A
    Exchange Version		: 2007 or later
    Author       				: Pat Richard, Exchange MVP
    Email/Blog/Twitter	: pat@innervation.com 	http://www.ehloworld.com @patrichard
    Dedicated Post			: http://www.ehloworld.com/175
    Disclaimer   				: You running this script means you won't blame me if this breaks your stuff.
    Info Stolen from 		: http://blog.flaphead.dns2go.com/archive/2009/07/29/system-uptime.aspx

.LINK     
		http://www.ehloworld.com/175

.INPUTS
		None. You cannot pipe objects to this script
		
.PARAMETER Demo
		Runs the script in demo mode. No emails are sent to the user(s), and onscreen output includes those who are expiring soon.

.PARAMETER Preview

.PARAMETER PreviewUser

.EXAMPLE 
		.\New-WelcomeEmail.ps1
		
		Description
		-----------
		
.EXAMPLE 
		.\New-WelcomeEmail.ps1 -Demo
		
		Description
		-----------

.EXAMPLE 
		.\New-WelcomeEmail.ps1 -Install
		
		Description
		-----------

.EXAMPLE 
		.\New-WelcomeEmail.ps1 -Preview -PreviewUser
		
		Description
		-----------

#> 
#Requires -Version 2.0  
param(
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$true, Mandatory=$false)] 
	[switch]$Demo,
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$true, Mandatory=$false)] 
	[switch]$Preview,
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$true, Mandatory=$false)] 
	[switch]$Install,
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$true, Mandatory=$false)] 
	[string]$PreviewUser,
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$true, Mandatory=$false)] 
	[switch]$Transcript,
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$true, Mandatory=$false, HelpMessage="Please specify a company name.")]
	[ValidateNotNullOrEmpty()] 
	[string]$Company = "Contoso Ltd",
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$true, Mandatory=$false, HelpMessage="Please specify an OWA URL")]
	[ValidateNotNullOrEmpty()]
	[string]$OwaUrl = "https://mail.contoso.com",
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$true, Mandatory=$false, HelpMessage="Please specify the IP address of your email server")]
	[ValidateNotNullOrEmpty()]
	[string]$EmailServer = "10.9.0.11",
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$true, Mandatory=$false, HelpMessage="Please specify a name and email address for the email 'from' field")]
	[ValidateNotNullOrEmpty()]
	[string]$EmailFrom = "Help Desk <helpdesk@contoso.com>",
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$true, Mandatory=$false)] 
	[string]$HelpDeskPhone = "(586) 555-1010",	
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$true, Mandatory=$false)] 
	[string] $TranscriptFilename = $MyInvocation.MyCommand.Name + " " + (hostname)+ " {0:yyyy-MM-dd hh-mmtt}.log" -f (Get-Date),
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$false, Mandatory=$false, HelpMessage="This must be zero")]
	[ValidateNotNullOrEmpty()]
	[int]$global:UsersNotified = 0,
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$true, Mandatory=$false)] 
	[string] $ImagePath = "http://www.innervation.com/crap/scripts/new-welcomeemail.ps1",
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$false, Mandatory=$false)][ValidateNotNullOrEmpty()]
	[string] $ScriptName = $MyInvocation.MyCommand.Name,
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$false, Mandatory=$false)][ValidateNotNullOrEmpty()]
	[string] $ScriptPathAndName = $MyInvocation.MyCommand.Definition,
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$false, Mandatory=$false)]
	[string] $HelpDeskURL = "https://intranet.contoso.com",
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$false, Mandatory=$false)]
	[string] $DirectoryUpdateURL = "https://directory.contoso.com",
	[parameter(ValueFromPipeline=$false, ValueFromPipelineByPropertyName=$false, Mandatory=$false)]
	[string] $HelpDeskEmail = "helpdesk@contoso.com"
)

if (!(Get-ItemProperty HKLM:\Software\Innervation\$ScriptName -Name LastRun -EA SilentlyContinue)){
	# this is the first time the script has run - let's create the registry key and value for future runs
	New-Item -path HKLM:\Software\Innervation -EA SilentlyContinue | Out-Null
	New-Item -path HKLM:\Software\Innervation\$ScriptName | Out-Null
	New-ItemProperty -path HKLM:\Software\Innervation\$ScriptName -Name "LastRun" -Value (Get-Date) -propertyType String | Out-Null
	write-host "Initial configuration completed." -ForegroundColor green
}
# get time stamp from registry so we know when it last ran
$LastRun = Get-Date ((Get-ItemProperty -path HKLM:\Software\Innervation\$ScriptName -Name LastRun).LastRun)
$ElapsedTime = ((Get-Date) - $lastrun).TotalSeconds

function Install	{
	# http://technet.microsoft.com/en-us/library/cc725744(WS.10).aspx
	$error.clear()
	Write-Host "Creating scheduled task `"$ScriptName`"...`n`n"
	[console]::ForegroundColor = "yellow"
	$TaskPassword = Read-Host "Please enter the password for $env:userdomain\$env:username" -AsSecureString
	[console]::ResetColor()
	$TaskPassword = [System.Runtime.InteropServices.Marshal]::PtrToStringAuto([System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($TaskPassword))
	schtasks /create /tn $ScriptName /tr "$env:windir\system32\windowspowershell\v1.0\powershell.exe -psconsolefile $env:ExchangeInstallPath\Bin\exshell.psc1 -command $ScriptPathAndName" /sc Daily /st 07:00 /ru $env:userdomain\$env:username /rp $TaskPassword | Out-Null
	if (!($error)){
		Write-Host "done!" -ForegroundColor green
	}else{
		Write-Host "failed!" -ForegroundColor red
	}
	exit
} # end function Install

if ($install){
	Install
}

$evt=new-object System.Diagnostics.EventLog("Application")
$evt.Source=$ScriptName
$infoevent=[System.Diagnostics.EventLogEntryType]::Information
$EventLogText = "Beginning processing"
$evt.WriteEntry($EventLogText,$infoevent,70)

if (!($preview)){
	$MBXArray = @(Get-Mailbox -ResultSize Unlimited | ? {($_.WhenCreated -gt (Get-Date).AddSeconds(-$ElapsedTime)) -and ($_.ExchangeUserAccountControl -ne "AccountDisabled")})
}else{
	$MBXArray = Get-User $PreviewUser 
}

ForEach ($mailbox in $MBXArray ) { 
$UserEmail = $mailbox.WindowsEmailAddress
$UserName = $mailbox.DisplayName
$UserSam = $mailbox.samaccountname

$EmailBody = @"
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	</head>
<body>
	<table id="email" border="0" cellspacing="0" cellpadding="0" width="655" align="center">
		<tr>
			<td colspan="4" align="left" valign="top"><img src="$ImagePath/spacer.gif" alt="" width="46" height="28" align="absMiddle"><font style="font-size: 10px; color: #000000; line-height: 16px; font-family: Verdana, Arial, Helvetica, sans-serif">If this e-mail does not appear properly, please <a href="$HelpDeskURL" style="font-weight: bold; font-size: 10px; color: #cc0000; font-family: verdana, arial, helvetica, sans-serif; text-decoration: underline" target="_blank">click here</a>.</font></td>
		</tr>
		<tr>
			<td colspan="4" height="121" align="left" valign="bottom"><a href="$HelpDeskURL" target="_blank"><img src="$ImagePath/header.gif" border="0" alt="Header" width="655" height="121"></a></td>
		</tr>
		<tr>
			<td colspan="4">
				<table id="body" border="0" cellspacing="0" cellpadding="0">
					<tr>
						<td width="1" align="left" valign="top" bgcolor="#a8a9ad"><img src="$ImagePath/spacer50.gif" alt="" width="1" height="50"></td>
						<td><img src="$ImagePath/spacer.gif" alt="" width="46" height="106"></td>
						<td id="text" width="572" align="left" valign="top" style="font-size: 12px; color: #000000; line-height: 17px; font-family: Verdana, Arial, Helvetica, sans-serif">
								<p style="font-weight: bold">Hello, $UserName,</p>
								<p>Welcome to the $company family! Please keep this email for future use. It contains vital information.</p>

<hr />
<span style="font-weight: bold">Username and password</span>
<hr />
<p>Your network username is '$UserSam'. Use your username and password to login to the network. Your password should NEVER be shared with anyone except the I.T. department, and only then when requested. Please do not write it down on anything that can be seen by your coworkers. You will be prompted to change it regularly.</p>

<hr />
<span style="font-weight: bold">Email</span>
<hr />
<p>Your email address is '$UserEmail'.</p>
<p>To access your email, calendar, contacts, and tasks from outside of the building, such as from home, you can do so from any Internet connected computer. Simply open Internet Explorer and go to the Outlook Web App (OWA) page at $OWAUrl and log in using your username and password. Please note the 's' in https.</p>
<p>If you'd like to have access to your email and contacts from your cell phone, you will need a cell phone that has Windows Mobile 5 or later, or an Apple iPhone. Blackberry phones are not supported. Instructions for configuring your device can be found in the Frequently Asked Questions (FAQ) section of the Contoso Intranet at $HelpDeskURL</p>
<hr />
<span style="font-weight: bold">Contact information</span>
<hr />
<p>Once you're situated, please go to $DirectoryUpdateURL and update your information. Log in using your username and password. It's important that you update your information anytime something changes, such as title, department, phone number, etc. This information is used in various systems and applications, and is your responsibility to keep up to date.</p>

<hr />
<span style="font-weight: bold">Computer, Email, and Internet policies</span>
<hr />
<p>Contoso, Inc. provides a computer for your work tasks. The use of personally owned computers and related equipment is not permitted on our network. Additional information about use of Contoso computers, email, Internet, etc. can be found in the Employee Handbook located in the HR section of the intranet at https://intranet.contoso.com/hr/</p>

<hr />
<span style="font-weight: bold">Technical assistance</span>
<hr />
<p>Should you need technical assistance, please check the Frequently Asked Questions (FAQ) section of the Contoso Intranet at $HelpDeskURL. If you cannot find an answer there, submit a Service Request on the Contoso intranet at $HelpDeskURL. If you are unable to access the intranet site, only then should you email $HelpDeskEmail. It is monitored by the whole IT department, and will ensure your issue is resolved in a timely manner.</p>

<p>Thank you, and, again, welcome to $company!<br />
The $company Help Desk<br />
$HelpDeskPhone</p>
								
							</td>
							<td width="49" align="left" valign="top"><img src="$ImagePath/spacer50.gif" alt="" width="49" height="50"></td>
							<td width="1" align="left" valign="top" bgcolor="#a8a9ad"><img src="$ImagePath/spacer50.gif" alt="" width="1" height="50"></td>
						</tr>
					</table>
					<table id="footer" border="0" cellspacing="0" cellpadding="0" width="655">
						<tr>
							<td colspan="3"><img src="$ImagePath/footer.gif" alt="© 2010 $company" width="655" height="81"></td>
						</tr>
					</table>
					<table border="0" cellspacing="0" cellpadding="0" width="655" align="center">
						<tr>
							<td align="left" valign="top"><img src="$ImagePath/spacer.gif" alt="" width="36" height="1"></td>
							<td align="left" valign="top"><font face="Verdana" size="1" color="#000000"><p>This email was sent by an automated process. If you would like to comment on it, please visit <a href="$HelpDeskURL"><font color="#ff0000"><u>click here</u></font></a>.</p>
								<p style="color: #009900;"><font face="Webdings" size="4">P</font> Please consider the environment before printing this email.</p></font>
							</td>
							<td align="left" valign="top"><img src="$ImagePath/spacer.gif" alt="" width="36" height="1"></td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
	</body>
</html>
"@
if (!($demo)){
	Send-MailMessage -To $UserEmail -Subject "Welcome to $company!" -Body $emailbody -From $EmailFrom -SmtpServer $EmailServer -Priority High -BodyAsHTML
	$global:UsersNotified++
}

}
$EventLogText = "Finished processing $global:UsersNotified account(s)"
$evt.WriteEntry($EventLogText,$infoevent,70)

# update registry here with a fresh time stamp
Set-ItemProperty HKLM:\Software\Innervation\$strScriptName -Name "LastRun" -Value (Get-Date) | Out-Null